<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑' : '添加'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="关联users表id" name="uid">
        <a-input
          allow-clear
          placeholder="请输入关联users表id"
          v-model:value="form.uid"
        />
      </a-form-item>
      <a-form-item label="充值订单号" name="orderNum">
        <a-input
          allow-clear
          placeholder="请输入充值订单号"
          v-model:value="form.orderNum"
        />
      </a-form-item>
      <a-form-item label="微信支付订单号" name="wechatOrder">
        <a-input
          allow-clear
          placeholder="请输入微信支付订单号"
          v-model:value="form.wechatOrder"
        />
      </a-form-item>
      <a-form-item label="充值金额" name="money">
        <a-input
          allow-clear
          placeholder="请输入充值金额"
          v-model:value="form.money"
        />
      </a-form-item>
      <a-form-item label="1已支付，2未支付" name="status">
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">显示</a-radio>
          <a-radio :value="1">隐藏</a-radio>
        </a-radio-group>
      </a-form-item>
      <a-form-item label="" name="vid">
        <a-input
          allow-clear
          placeholder="请输入"
          v-model:value="form.vid"
        />
      </a-form-item>
      <a-form-item label="" name="isInvoice">
        <a-input
          allow-clear
          placeholder="请输入"
          v-model:value="form.isInvoice"
        />
      </a-form-item>
      <a-form-item label="对账情况：1=已对账；2=未对账；3=已对账，金额对不上；4=未查询到该订单" name="checkBill">
        <a-input
          allow-clear
          placeholder="请输入对账情况：1=已对账；2=未对账；3=已对账，金额对不上；4=未查询到该订单"
          v-model:value="form.checkBill"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkRechargeLog, updateThinkRechargeLog } from '@/api/think/thinkRechargeLog';
  import { ThinkRechargeLog } from '@/api/think/thinkRechargeLog/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkRechargeLog | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkRechargeLog>({
    id: undefined,
    uid: undefined,
    orderNum: undefined,
    wechatOrder: undefined,
    money: undefined,
    status: undefined,
    createTime: undefined,
    vid: undefined,
    isInvoice: undefined,
    checkBill: undefined,
    thinkRechargeLogId: undefined,
    thinkRechargeLogName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkRechargeLogName: [
      {
        required: true,
        type: 'string',
        message: '请填写名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateThinkRechargeLog : addThinkRechargeLog;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
